function PageLinker(map, aElementId)
{
  this._map = map;
  this._elementId = aElementId;

  PageLinker.url2Map( map );
  
  GEvent.bind( this._map, "maptypechanged", this, this._regenerateUrl );
  GEvent.bind( this._map, "moveend", this, this._regenerateUrl );
  if ( this._map.isLoaded() )
    this._regenerateUrl();
}

PageLinker.getQueryVars = function()
{
  var vars = {};
  var qString = unescape( top.location.search.substring(1) );
  if (qString.length==0)
    return vars;
  var pairs = qString.split(/\&/);
  for (var i=0; i<pairs.length; i++ )
  {
    var nameVal = pairs[i].split(/\=/);
    vars[nameVal[0]] = nameVal[1];
  }
  return vars;
};

PageLinker.map2Url = function( map )
{
  var vars = PageLinker.getQueryVars();
  vars['ll'] = map.getCenter().toUrlValue(5);
  vars['z'] = map.getZoom();
  switch ( map.getCurrentMapType() )
  {
    case G_SATELLITE_MAP: vars['t']='k'; break;
    case G_HYBRID_MAP:    vars['t']='h'; break;
    default: if (vars['t']) vars['t']=null; break;
  }
  
  var url = document.location.protocol+'//'+document.location.hostname+document.location.pathname;
    
  var bFirst = true;
  for (var key in vars)
  {
    url += bFirst ? "?" : "&";
    bFirst = false;
    url += key;
    if (vars[key]!=null)
      url += "="+vars[key];
  }
  return url;
};

PageLinker.url2Map = function( map )
{
  var vars = PageLinker.getQueryVars();
  if ( !( (vars['z'] && vars['ll']) || vars['t'] ) )
    return;

  var mapType = G_NORMAL_MAP;
  switch (vars['t'])
  {
    case 'k': mapType = G_SATELLITE_MAP; break;
    case 'h': mapType = G_HYBRID_MAP; break;
  }
  
  if (vars['z'] && vars['ll'])
  {
    var zoom = parseFloat(vars['z']);
    var ll = vars['ll'].split( "," );
    if (ll.length==2)
    {
      var center = new GLatLng( ll[0], ll[1] );
      map.setCenter( center, zoom, mapType );
    }
  }
}


PageLinker.prototype = {

_regenerateUrl: function()
{
  var elt = document.getElementById( this._elementId );
  if (!elt) return;
  elt.href = PageLinker.map2Url(this._map);
}

}
